map S32 Answer_Header as input 0x2400:01
map S32 Answer_Value as input 0x2400:02
map S32 Request_Header as output 0x2500:01
map S32 Request_Value as output 0x2500:02

#include "wrapper.h"

U16 Answer_Address;
bool Answer_Toggle_Bit;	
bool Toggle_Bit[64];	

void Config_PDOs()	//sets up the PDO-Mapping between the Master and the Slave
{
	if(od_read(0x1F80, 0x00) != 0x08)
	{	
		od_write(0x1400, 0x01, (od_read(0x1400, 0x01) | 0x80000000));
		od_write(0x1401, 0x01, (od_read(0x1401, 0x01) | 0x80000000));
		od_write(0x1402, 0x01, (od_read(0x1402, 0x01) | 0x80000000));
		od_write(0x1403, 0x01, (od_read(0x1403, 0x01) | 0x80000000));
		yield();
		od_write(0x1404, 0x01, (od_read(0x1404, 0x01) | 0x80000000));
		od_write(0x1405, 0x01, (od_read(0x1405, 0x01) | 0x80000000));
		od_write(0x1406, 0x01, (od_read(0x1406, 0x01) | 0x80000000));
		od_write(0x1407, 0x01, (od_read(0x1407, 0x01) | 0x80000000));	
		yield();
		od_write(0x1800, 0x01, (od_read(0x1800, 0x01) | 0x80000000));
		od_write(0x1801, 0x01, (od_read(0x1801, 0x01) | 0x80000000));
		od_write(0x1802, 0x01, (od_read(0x1802, 0x01) | 0x80000000));
		od_write(0x1803, 0x01, (od_read(0x1803, 0x01) | 0x80000000));
		yield();
		od_write(0x1804, 0x01, (od_read(0x1804, 0x01) | 0x80000000));
		od_write(0x1805, 0x01, (od_read(0x1805, 0x01) | 0x80000000));
		od_write(0x1806, 0x01, (od_read(0x1806, 0x01) | 0x80000000));
		od_write(0x1807, 0x01, (od_read(0x1807, 0x01) | 0x80000000));	
		yield();
		od_write(0x1604, 0x00, 0x00);
		od_write(0x1A04, 0x00, 0x00);	
		od_write(0x1404, 0x02, 0xFF);
		od_write(0x1804, 0x02, 0xFF);	
		od_write(0x1804, 0x03, 0x64);	
		yield();
		od_write(0x1604, 0x01, 0x24000120);
		od_write(0x1604, 0x02, 0x24000220);	
		od_write(0x1604, 0x00, 0x02);
		yield();	
		od_write(0x1A04, 0x01, 0x25000120);
		od_write(0x1A04, 0x02, 0x25000220);	
		od_write(0x1A04, 0x00, 0x02);	
		yield();
		od_write(0x1404, 0x01, 0x333);	
		od_write(0x1804, 0x01, 0x222);
		yield();
		od_write(0x1005, 0x00, 0x40000080);
		od_write(0x1006, 0x00, 0x2710);	
		od_write(0x1F80, 0x00, 0x08);
		yield();	
		od_write(0x1010, 0x02, 0x65766173);
		yield();
		while(od_read(0x1010, 0x02)!= 0x01)
		{
			yield();
		}
		od_write(0x2800, 0x01, 0x746F6F62);		
		yield();	
	}				
}

bool Reset_Toggle_Bits()	//resets the toggle-bits of all Slaves (necessary to detect a new message)
{
	Out.Request_Value 	= 	0;
	Out.Request_Header 	= 	1u << 24u;
	for (int x = 0; x < 64 ; ++x) 
	{
		Toggle_Bit[x] = true;
	}
	sleep(10);
	return true;
}

bool Send_Write_Request(U16 Address, U16 Index, U08 SubIndex, S32 Value)	//sends a value to an index of the addressed Slave
{
	Out.Request_Value 	= 	Value;
	Out.Request_Header 	= 	((1u << 30u) + (Toggle_Bit[Address] << 31u) + (Address << 24u) + (Index << 8u) + (SubIndex));
	
	while(In.Answer_Header != Out.Request_Header)
	{
		yield();			
	}

	Toggle_Bit[Address] = !Toggle_Bit[Address];
	return true;
}

S32 Send_Read_Request(U16 Address, U16 Index, U08 SubIndex)			//reads the value of an index of the addressed Slave
{
	Out.Request_Value 	= 	0;
	Out.Request_Header 	= 	( (Toggle_Bit[Address] << 31u) + (Address << 24u) + (Index << 8u) + (SubIndex));
	
	while(In.Answer_Header != Out.Request_Header)
	{
		yield();			
	}
	
	Toggle_Bit[Address] = !Toggle_Bit[Address];
	return In.Answer_Value;
}
	
void user()
{
	Config_PDOs();
	od_write(0x2300, 0x00, 0x05);
	sleep(4000);
	Reset_Toggle_Bits();	
	Answer_Toggle_Bit = false;		
	yield();
	
	//from this point on you can write your own code

	Send_Write_Request(2,0x6060, 0x00, 8);
	Send_Write_Request(2,0x60C2, 0x01, 10);	
	Send_Write_Request(2,0x6040, 0x00, 6);		
	Send_Write_Request(2,0x6040, 0x00, 7);
	Send_Write_Request(2,0x6040, 0x00, 15);	
						
	while(true)
	{		
		Send_Write_Request(2,0x607A, 0x00, od_read(0x6064, 0x00));
		yield();
	}	
}
